// FileDialog_NonModalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FileDialog_NonModal.h"
#include "FileDialog_NonModalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDialog_NonModalDlg dialog

CFileDialog_NonModalDlg::CFileDialog_NonModalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileDialog_NonModalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileDialog_NonModalDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	_pFileDialog = NULL;
}

void CFileDialog_NonModalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileDialog_NonModalDlg)
	DDX_Control(pDX, IDC_STATIC_REPORT, m_staticOutput);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileDialog_NonModalDlg, CDialog)
	//{{AFX_MSG_MAP(CFileDialog_NonModalDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDialog_NonModalDlg message handlers

BOOL CFileDialog_NonModalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFileDialog_NonModalDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFileDialog_NonModalDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFileDialog_NonModalDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFileDialog_NonModalDlg::OnButtonSelect() 
{
	// TODO: Add your control notification handler code here
   static char szFilters[] = "Text Files (*.txt)|*.txt|"
		"All Files (*.*)|*.*||";
   static counter = 0;

   if (counter == 0)
   {
      _path = "C:\\";
      _file = "error.txt";
   }

	if (_pFileDialog == NULL)
	{
		_pFileDialog = new CNonModalFileDialog (this, false, _path, 
         true,
         NULL, 
         _file, 
         OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
         szFilters);
	}
	else
	{
		_pFileDialog->Show ();
	}

   counter++;
	
}

void CFileDialog_NonModalDlg::OnFileDialogOK (CFileDialog *dlg)
{
   //---------------------------------
   // Acquire the path and filename.
   //---------------------------------
   _path = dlg->GetPathName ();
   _file = dlg->GetFileName ();
   if (!_path.IsEmpty () && !_file.IsEmpty ())
   {
      _path.SetAt (
	   _path.GetLength() - _file.GetLength(),
      '\0');
   }

	m_staticOutput.SetWindowText ((LPCSTR)dlg->GetPathName ());
  	_pFileDialog = NULL;
}

void CFileDialog_NonModalDlg::OnFileDialogCANCEL (void)
{
	_pFileDialog = NULL;
}

